static final int DOWN_KEY  = 0;
static final int UP_KEY    = 1;
static final int LEFT_KEY  = 2;
static final int RIGHT_KEY = 3;

static final float REACH_FACTOR = 1.05;
static final float MIN_REACH    = 0.05;
static final float MAX_REACH    = 10.0;

static final float COHERENCE_STEP = 0.05;
static final float MIN_COHERENCE  = 0.01;
static final float MAX_COHERENCE  = 0.99;

static final int LOTZE_STACK      = 0;
static final int HELMHOLTZ_STACK  = 1;
static final int COHERENT_STACK   = 2;
static final int NUM_NOISE_FIELDS = 3;
int theNoiseField = LOTZE_STACK;

static final int DISARRAY_RESULT = 0;
static final int NOISE_FIELDS    = 1;
static final int DATA_STACKS     = 2;
static final int NUM_MODES       = 3;
int mode = DISARRAY_RESULT;

static final int IMAGE_STACK       = 0;
static final int MACCHIE           = 1;
static final int LAPLACEAN_STACK   = 2;
static final int EDGE_FINDER_STACK = 3;
static final int EDGELETS          = 4;
static final int LINE_FINDER_STACK = 5;
static final int NUM_STACKS        = 6;
int theStack = IMAGE_STACK;

static final int FIDUCIAL_IMAGE              = 0;
static final int LOTZE_DISARRAY              = 1;
static final int HELMHOLTZ_DISARRAY          = 2;
static final int COHERENT_DISARRAY           = 3;
static final int PARTIALLY_COHERENT_DISARRAY = 4;
static final int NUM_RESULT_DISPLAY_MODES    = 5;
int resultDisplayMode = FIDUCIAL_IMAGE;

static final int DEMO_MODE = 0;
static final int TEXT_MODE = 1;
int displayMode = DEMO_MODE;

PFont font, altFont;
static final int MARGIN            = 10;
static final int LINEHEIGHT        = 30;
int              FONT_SIZE         = ceil(SZ/22);
int              SMALL_FONT_SIZE   = ceil(SZ/32);
color            FONT_COLOR        = color(0,255,0);
color            BOTTOM_LINE_COLOR = color(255,127,0);
color            HEADING_COLOR     = color(255,255,0);

float reach      = 1.0;
float coherence  = 0.5;
int   stackLevel = 0;

PImage theCurrentlyDisplayedImage; 

String fileSaveReport = "";

ArrayList<PImage> HELP = new ArrayList<PImage>();
ArrayList<PImage> A_0 = new ArrayList<PImage>();
ArrayList<PImage> A_1 = new ArrayList<PImage>();
ArrayList<PImage> A_2 = new ArrayList<PImage>();
ArrayList<PImage> A_3 = new ArrayList<PImage>();
ArrayList<PImage> A_4 = new ArrayList<PImage>();
ArrayList<PImage> B_0 = new ArrayList<PImage>();
ArrayList<PImage> B_1 = new ArrayList<PImage>();
ArrayList<PImage> B_2 = new ArrayList<PImage>();
ArrayList<PImage> C_0 = new ArrayList<PImage>();
ArrayList<PImage> C_1 = new ArrayList<PImage>();
ArrayList<PImage> C_2 = new ArrayList<PImage>();
ArrayList<PImage> C_3 = new ArrayList<PImage>();
ArrayList<PImage> C_4 = new ArrayList<PImage>();
ArrayList<PImage> C_5 = new ArrayList<PImage>();

boolean helpMode = false;

int manualPage = 0;

void mouseClicked() {
  if (imageHasBeenDefined) {
    userStartedInterface = true;
    redraw();
  }
  if (userStartedInterface) {
    if      (displayMode == DEMO_MODE && mouseX<SZ) {
      displayMode = TEXT_MODE;
      manualPage = 0;
    }
    else if (displayMode == TEXT_MODE) displayMode = DEMO_MODE;
  }
}

void keyPressed(){
  if (key==CODED) {
    if (displayMode == DEMO_MODE) {
      if      (keyCode== DOWN) handleArrowKeys(0);
      else if (keyCode==   UP) handleArrowKeys(1);
      else if (keyCode== LEFT) handleArrowKeys(2);
      else if (keyCode==RIGHT) handleArrowKeys(3);
    }
    else {
      if      (keyCode== LEFT) { manualPage--; redraw();}
      else if (keyCode==RIGHT) { manualPage++; redraw();}
    }
  }
  else if (key==' ') redraw();
  else if (key=='0') handleNumericKeys(0);
  else if (key=='1') handleNumericKeys(1);
  else if (key=='2') handleNumericKeys(2);
  else if (key=='3') handleNumericKeys(3);
  else if (key=='4') handleNumericKeys(4);
  else if (key=='5') handleNumericKeys(5);
  else if (key=='6') handleNumericKeys(6);
  else if ((key=='a')||(key=='A')) handleLetterKeys(0);
  else if ((key=='b')||(key=='B')) handleLetterKeys(1);
  else if ((key=='c')||(key=='C')) handleLetterKeys(2);
  else if ((key=='h')||(key=='H')) { helpMode = true; redraw();}
  else if ((key==RETURN)||(key==ENTER)) selectOutput("Select a file to write to:", "outputFileSelected");
}

void outputFileSelected(File selection) {
  if (selection == null) {
    fileSaveReport = "File selection failed!";
  } 
  else {
    theCurrentlyDisplayedImage.save(selection.getAbsolutePath());
    fileSaveReport = "File saved!";
  }
  redraw();
}

void handleArrowKeys(int theKey) {
  switch (mode) {
    case DISARRAY_RESULT:
      switch (theKey) {
        case DOWN_KEY:
          reach /= REACH_FACTOR;
          if (reach<0.001) reach = MIN_REACH;
          redraw();
          break;
        case UP_KEY:
          reach *= REACH_FACTOR;
          if (reach>1000.0) reach = MAX_REACH;
          redraw();
          break;
        case LEFT_KEY:
          coherence -= COHERENCE_STEP;
          if (coherence<0.01) coherence = MIN_COHERENCE;
          redraw();
          break;
        case RIGHT_KEY:
          coherence += COHERENCE_STEP;
          if (coherence>0.99) coherence = MAX_COHERENCE;
          redraw();
          break;
      }
      break;
    case NOISE_FIELDS:
    case DATA_STACKS:
      switch (theKey) {
        case DOWN_KEY:
          stackLevel--;
          if (stackLevel<0) stackLevel = 0;
          redraw();
          break;
        case UP_KEY:
          stackLevel++;
          if (stackLevel>=NUM_SCALES) stackLevel = NUM_SCALES-1;
          redraw();
          break;
      }
      break;
  }
}

void handleLetterKeys(int i){
  mode = i;
  if      (mode<0)          mode = DISARRAY_RESULT;
  else if (mode>=NUM_MODES) mode = DATA_STACKS;
  switch (mode) {
    case DISARRAY_RESULT: { resultDisplayMode = FIDUCIAL_IMAGE; break;}
    case NOISE_FIELDS   : { theNoiseField     = LOTZE_STACK;    break;}
    case DATA_STACKS    : { theStack          = IMAGE_STACK;    break;}
  }
  redraw();
}

void handleNumericKeys(int i) {
  switch (mode) {
    case DISARRAY_RESULT:
      resultDisplayMode = i;
      if (resultDisplayMode<0) resultDisplayMode=FIDUCIAL_IMAGE; 
      else if (resultDisplayMode>=NUM_RESULT_DISPLAY_MODES) resultDisplayMode = PARTIALLY_COHERENT_DISARRAY;
      redraw();
    case NOISE_FIELDS:
      theNoiseField = i;
      if (theNoiseField<0) theNoiseField=LOTZE_STACK; 
      else if (theNoiseField>=NUM_NOISE_FIELDS) theNoiseField = COHERENT_STACK;
      redraw();
      break;
    case DATA_STACKS:
      theStack = i;
      if (theStack<0) theStack=IMAGE_STACK; 
      else if (theStack>=NUM_STACKS) theStack = LINE_FINDER_STACK;
      redraw();
      break;
  }
}

void resultsMenu(int rdm) {
  switch (rdm) {
    case FIDUCIAL_IMAGE:
      textFont(font,SMALL_FONT_SIZE);
      text("UP-DOWN arrow keys to adjust reach",         SZ+MARGIN, 7*LINEHEIGHT);
      text("Reach = "+nf(reach,3,3),                     SZ+MARGIN, 8*LINEHEIGHT);
      text("LEFT-RIGHT keys to adjust grain-size",  SZ+MARGIN, 9*LINEHEIGHT);
      int lev = round(coherence*NUM_SCALES);
      if (lev<0) lev=0; else if (lev>=NUM_SCALES) lev = NUM_SCALES-1;
      text("Grain-size = "+nf(scales[lev],3,3), SZ+MARGIN, 10*LINEHEIGHT);
      break;
    case LOTZE_DISARRAY:
    case HELMHOLTZ_DISARRAY:
    case COHERENT_DISARRAY:
      text("UP-DOWN arrow keys to adjust reach",         SZ+MARGIN, 7*LINEHEIGHT);
      text("Reach = "+nf(reach,3,3),                     SZ+MARGIN, 8*LINEHEIGHT);
      text("LEFT-RIGHT keys to adjust grain-size",       SZ+MARGIN, 9*LINEHEIGHT);
      lev = round(coherence*NUM_SCALES);
      if (lev<0) lev=0; else if (lev>=NUM_SCALES) lev = NUM_SCALES-1;
      text("Grain-size = "+nf(scales[lev],3,3),          SZ+MARGIN, 10*LINEHEIGHT);
      break;
    case PARTIALLY_COHERENT_DISARRAY:
      text("UP-DOWN arrow keys to adjust reach",         SZ+MARGIN, 7*LINEHEIGHT);
      text("LEFT-RIGHT arrow keys to adjust coherence",  SZ+MARGIN, 8*LINEHEIGHT);
      text("Reach = "+nf(reach,3,3),                     SZ+MARGIN, 9*LINEHEIGHT);
      text("Coherence = "+nf(coherence,1,3),             SZ+MARGIN, 10*LINEHEIGHT);
      break;
  }
  textFont(font,SMALL_FONT_SIZE);
  fill(BOTTOM_LINE_COLOR);
  text("SPACE_BAR computes new instance",                                   SZ+MARGIN, SZ-2.5*LINEHEIGHT);
  text("0 fiducial, 1 Lotze, 2 Helmholtz, 3 Coherent, 4 Partial coherence", SZ+MARGIN, SZ-1.5*LINEHEIGHT);
  text("A disarray instances, B noise fields, C data stacks",               SZ+MARGIN, SZ-0.5*LINEHEIGHT);
  fill(FONT_COLOR); 
  textFont(font, FONT_SIZE); 
}

void noiseFieldsMenu(int nf) {
  fill(HEADING_COLOR);
  switch(nf){
    case LOTZE_STACK:
      text("B.0. Lotze disarray",                                                      SZ+MARGIN, LINEHEIGHT);
      fill(FONT_COLOR);
      text("UP/DOWN keys to change grain",                                             SZ+MARGIN,  3*LINEHEIGHT);
      text("Grain = "+nf(effectiveScales[stackLevel],3,3),                             SZ+MARGIN,  4*LINEHEIGHT);
      break;
    case HELMHOLTZ_STACK:
      text("B.1. Helmholtz stack",                                                     SZ+MARGIN, LINEHEIGHT);
      fill(FONT_COLOR);
      text("UP/DOWN keys to change level",                                             SZ+MARGIN,  3*LINEHEIGHT);
      text("Level = "+stackLevel+" (sigma = "+nf(effectiveScales[stackLevel],3,3)+")", SZ+MARGIN,  4*LINEHEIGHT);
      break;
    case COHERENT_STACK:
      text("B.2. Coherent stack",                                                      SZ+MARGIN, LINEHEIGHT);
      fill(FONT_COLOR);
      text("UP/DOWN keys to change level",                                             SZ+MARGIN,  3*LINEHEIGHT);
      text("Level = "+stackLevel+" (sigma = "+nf(effectiveScales[stackLevel],3,3)+")", SZ+MARGIN,  4*LINEHEIGHT);
      break;
  }
  
  textFont(font,SMALL_FONT_SIZE);
  fill(BOTTOM_LINE_COLOR);
  text("SPACE_BAR computes new instance",                                              SZ+MARGIN, SZ-2.5*LINEHEIGHT);
  text("0 Lotze disarray, 1 Helmholtz stack, 2 Coherent stack",                        SZ+MARGIN, SZ-1.5*LINEHEIGHT);
  text("A disarray instances, B noise fields, C data stacks",                          SZ+MARGIN, SZ-0.5*LINEHEIGHT);
  fill(FONT_COLOR); 
  textFont(font, FONT_SIZE); 
}

void dataStacksMenu(int ds) {
  fill(HEADING_COLOR);
  switch(ds){
    case IMAGE_STACK:
      text("C.0. Image scale space", SZ+MARGIN, LINEHEIGHT);
      break;
    case MACCHIE:
      text("C.1. Macchie scale space", SZ+MARGIN, LINEHEIGHT);
      break;
    case LAPLACEAN_STACK:
      text("C.2. Pointlet stack ('D.O.G.s')", SZ+MARGIN, LINEHEIGHT);
      break;
    case EDGE_FINDER_STACK:
      text("C.3. Edginess stack ('edge finders')", SZ+MARGIN, LINEHEIGHT);
      image(directionColorScale(),1.7*SZ,0.3*SZ,0.25*SZ,0.25*SZ);
      textFont(font,SMALL_FONT_SIZE);
      fill(255);
      text("direction color scale",1.3*SZ,0.4*SZ);
      textFont(font,FONT_SIZE);
      break;
    case EDGELETS:
      text("C.4. Edgelets stack", SZ+MARGIN, LINEHEIGHT);
      break;
    case LINE_FINDER_STACK:
      text("C.5. Ridginess stack ('line finders')", SZ+MARGIN, LINEHEIGHT);
      image(lineFinderBasisColorScale(),1.7*SZ,0.3*SZ,0.25*SZ,0.25*SZ);
      textFont(font,SMALL_FONT_SIZE);
      fill(255);
      text("orientation color scale",1.3*SZ,0.4*SZ);
      textFont(font,FONT_SIZE);
      break;
  }
  fill(FONT_COLOR);
  text("UP/DOWN keys to change level",                                    SZ+MARGIN,  3*LINEHEIGHT);
  text("Level = "+stackLevel+" (sigma = "+nf(scales[stackLevel],3,3)+")", SZ+MARGIN,  4*LINEHEIGHT);
  textFont(font,SMALL_FONT_SIZE);
  fill(BOTTOM_LINE_COLOR);
  text("SPACE_BAR computes new instance",                    SZ+MARGIN, SZ-2.5*LINEHEIGHT);
  text("0 Image, 1 Macchie, 2 DOGs, 3 1st ord., 4 Edgelets, 5 2nd ord.",    SZ+MARGIN, SZ-1.5*LINEHEIGHT);
  text("A disarray instances, B noise fields, C data stacks",SZ+MARGIN, SZ-0.5*LINEHEIGHT);
  fill(FONT_COLOR); 
  textFont(font, FONT_SIZE); 
}

String[] stateDescription() {
  StringList sl = new StringList();
  switch (mode){
    case DISARRAY_RESULT : {sl.append("Disarray result"); break;}
    case NOISE_FIELDS    : {sl.append("Noise field"); break;}
    case DATA_STACKS     : {sl.append("Datastack"); break;}
  }
  switch (resultDisplayMode){
    case FIDUCIAL_IMAGE              : {sl.append("Fiducial image"); break;}
    case LOTZE_DISARRAY              : {sl.append("Lotze disarray"); break;}
    case HELMHOLTZ_DISARRAY          : {sl.append("Helmholtz disarray"); break;}
    case COHERENT_DISARRAY           : {sl.append("Coherent disarray"); break;}
    case PARTIALLY_COHERENT_DISARRAY : {sl.append("Partially coherent disarray"); break;}
  }
  switch (theNoiseField){
    case LOTZE_STACK      : {sl.append("Lotze stack"); break;}
    case HELMHOLTZ_STACK  : {sl.append("Helmholtz stack"); break;}
    case COHERENT_STACK   : {sl.append("Coherent stack"); break;}
  }
  switch (theStack){
    case IMAGE_STACK       : {sl.append("Image scale space"); break;}
    case MACCHIE           : {sl.append("Macchie");}
    case LAPLACEAN_STACK   : {sl.append("Laplacean scale space"); break;}
    case EDGE_FINDER_STACK : {sl.append("Edginess stack"); break;}
    case EDGELETS          : {sl.append("Edgelets stack"); break;}
    case LINE_FINDER_STACK : {sl.append("Line finder stack"); break;}
  }
  sl.append("scale = "+scales[stackLevel]);
  sl.append("effective scale = "+effectiveScales[stackLevel]);
  sl.append("stackLevel = "+stackLevel);
  sl.append("reach = "+reach);
  sl.append("coherence  = "+coherence);
  return sl.array();
}

void limitManualPage(int numPages) {
  if      (manualPage > numPages-1) manualPage =          0;
  else if (manualPage <          0) manualPage = numPages-1;
}

void manual(int mode, int type) {
  background(255);
  if (helpMode) { limitManualPage(HELP.size()); image(HELP.get(manualPage),0,0,2*SZ,SZ);}
  else
    switch (mode) {
      case DISARRAY_RESULT:
        switch (type) {
          case FIDUCIAL_IMAGE:              limitManualPage(A_0.size()); image(A_0.get(manualPage),0,0,2*SZ,SZ); break;
          case LOTZE_DISARRAY:              limitManualPage(A_1.size()); image(A_1.get(manualPage),0,0,2*SZ,SZ); break;
          case HELMHOLTZ_DISARRAY:          limitManualPage(A_2.size()); image(A_2.get(manualPage),0,0,2*SZ,SZ); break;
          case COHERENT_DISARRAY:           limitManualPage(A_3.size()); image(A_3.get(manualPage),0,0,2*SZ,SZ); break;
          case PARTIALLY_COHERENT_DISARRAY: limitManualPage(A_4.size()); image(A_4.get(manualPage),0,0,2*SZ,SZ); break;
        }
        break;
      case NOISE_FIELDS: 
        switch (type) {
          case LOTZE_STACK:                 limitManualPage(B_0.size()); image(B_0.get(manualPage),0,0,2*SZ,SZ); break;
          case HELMHOLTZ_STACK:             limitManualPage(B_1.size()); image(B_1.get(manualPage),0,0,2*SZ,SZ); break;
          case COHERENT_STACK:              limitManualPage(B_2.size()); image(B_2.get(manualPage),0,0,2*SZ,SZ); break;
        }
        break;
      case DATA_STACKS: 
        switch(type){
          case IMAGE_STACK:                 limitManualPage(C_0.size()); image(C_0.get(manualPage),0,0,2*SZ,SZ); break;
          case MACCHIE:                     limitManualPage(C_1.size()); image(C_1.get(manualPage),0,0,2*SZ,SZ); break;
          case LAPLACEAN_STACK:             limitManualPage(C_2.size()); image(C_2.get(manualPage),0,0,2*SZ,SZ); break;
          case EDGE_FINDER_STACK:           limitManualPage(C_3.size()); image(C_3.get(manualPage),0,0,2*SZ,SZ); break;
          case EDGELETS:                    limitManualPage(C_4.size()); image(C_4.get(manualPage),0,0,2*SZ,SZ); break;
          case LINE_FINDER_STACK:           limitManualPage(C_5.size()); image(C_5.get(manualPage),0,0,2*SZ,SZ); break;
        }
        break;
    }
}

void loadManualPages() {
  // HELP
  HELP.add(loadImage("HELP.png"));
  // A
  A_0.add(loadImage("A0a.png"));
  A_0.add(loadImage("A0b.png"));
  A_0.add(loadImage("A0c.png"));
  
  A_1.add(loadImage("A1a.png"));
  A_1.add(loadImage("A1b.png"));
  A_1.add(loadImage("A1c.png"));
  
  A_2.add(loadImage("A2.png"));
  
  A_3.add(loadImage("A3a.png"));
  A_3.add(loadImage("A3b.png"));
  A_3.add(loadImage("A3c.png"));
  A_3.add(loadImage("A3d.png"));
  A_3.add(loadImage("A3e.png"));
  
  A_4.add(loadImage("A4.png"));
  
  // B
  B_0.add(loadImage("B0.png"));
  
  B_1.add(loadImage("B1.png"));
  
  B_2.add(loadImage("B2.png"));
  
  // C
  C_0.add(loadImage("C0a.png"));
  C_0.add(loadImage("C0b.png"));
  C_0.add(loadImage("C0c.png"));
  
  C_1.add(loadImage("C1a.png"));
  C_1.add(loadImage("C1b.png"));
  
  C_2.add(loadImage("C2.png"));
  
  C_3.add(loadImage("C3a.png"));
  C_3.add(loadImage("C3b.png"));
  
  C_4.add(loadImage("C4a.png"));
  C_4.add(loadImage("C4b.png"));
  C_4.add(loadImage("C4c.png"));
  C_4.add(loadImage("C4d.png"));
  
  C_5.add(loadImage("C5a.png"));
  C_5.add(loadImage("C5b.png"));
  C_5.add(loadImage("C5c.png"));
  C_5.add(loadImage("C5d.png"));
  C_5.add(loadImage("C5e.png"));
} 